## apbs 3.4.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.16)

###############################################################################
#  Get the Current Version Number so that it can be embedded in files later
###############################################################################
file(STRINGS "${CMAKE_CURRENT_LIST_DIR}/VERSION" _VERSION_DATA REGEX ^[0-9]+_[0-9]+_[0-9]+)
string(REPLACE "_" ";" _VERSION_LIST ${_VERSION_DATA})
list(GET _VERSION_LIST 0 MAJOR_VERSION)
list(GET _VERSION_LIST 1 MINOR_VERSION)
list(GET _VERSION_LIST 2 MICRO_VERSION)

set(CMAKE_PROJECT_VERSION ${MAJOR_VERSION}.${MINOR_VERSION}.${MICRO_VERSION})

################################################################################
# TODO:  Add licensing and authorship information
# TODO:  Test with FEtk build
# TODO:  Handle special mac dependencies
#        (configure.ac:1306)
################################################################################
#set(CMAKE_VERBOSE_MAKEFILE false)
cmake_policy(SET CMP0042 NEW) # MacOS RPATH on by default
cmake_policy(SET CMP0048 NEW) # project() command manages the VERSION variables
cmake_policy(SET CMP0054 NEW) # Only interpret if() arguments as variables or keywords when unquoted
cmake_policy(SET CMP0077 NEW) # option() honors normal variables (i.e. does nothing if a normal variable with the same name exists)
cmake_policy(SET CMP0083 NEW) # Pass flags needed for position-independent executables
cmake_policy(SET CMP0091 NEW) # MSVC runtime library flags are selected by an abstraction (i.e. CMAKE_MSVC_RUNTIME_LIBRARY)
set(CMAKE_MACOSX_RPATH 1)

################################################################################
# Set up basic project stuff                                                   #
################################################################################
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(ExternalProject)
include(FetchContent)
include(FeatureSummary)
include(InstallRequiredSystemLibraries)

set(APBS_VERSION     "${MAJOR_VERSION}.${MINOR_VERSION}.${MICRO_VERSION}")
set(PACKAGE_STRING   "APBS ${APBS_VERSION}")
set(CMAKE_BUILD_TYPE "RELWITHDEBINFO")

################################################################################
#  NOTE: Overwrite the RPATH information during the install from
#  https://gitlab.kitware.com/cmake/community/-/wikis/doc/cmake/RPATH-handling
################################################################################
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
#include(GNUInstallDirs)
#file(RELATIVE_PATH relDir
#     ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}
#     ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}
#)
#set(CMAKE_INSTALL_RPATH $ORIGIN $ORIGIN/${relDir})

project("APBS" VERSION ${APBS_VERSION})
set(CMAKE_PROJECT_DESCRIPTION "Adaptive Poisson-Boltzmann Solver")
set(CMAKE_PROJECT_HOMEPAGE_URL "http://www.poissonboltzmann.org/")

set_package_properties(APBS PROPERTIES
    URL "${CMAKE_PROJECT_HOMEPAGE_URL}"
    DESCRIPTION "${CMAKE_PROJECT_DESCRIPTION}"
    PURPOSE "APBS solves the equations of continuum electrostatics for large \
             biomolecular assemblages. This software was designed 'from the \
             ground up' using modern design principles to ensure its ability \
             to interface with other computational packages and evolve as \
             methods and applications change over time. The APBS code is \
             accompanied by extensive documentation for both users and \
             programmers and is supported by a variety of utilities for \
             preparing calculations and analyzing results. Finally, the free, \
             open-source APBS license ensures its accessibility to the entire \
             biomedical community.")

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

if(CMAKE_TOOLCHAIN_FILE)
    message(STATUS "Toolchain file is set to <${CMAKE_TOOLCHAIN_FILE}>.  Including the file.")
    include(${CMAKE_TOOLCHAIN_FILE})
endif()

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}" CACHE PATH "Install prefix" FORCE)
endif()
message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")

set(CMAKE_INSTALL_DATAROOTDIR "share/apbs")
include(GNUInstallDirs)

set(APBS_ROOT ${PROJECT_SOURCE_DIR})
set(APBS_BUILD ${PROJECT_BINARY_DIR})
set(TOOLS_PATH ${APBS_BUILD}/tools)

set(APBS_LIBS)
set(APBS_LIB_DIRS)

set(PYTHON_VERSION 3.6 CACHE STRING "Python version to be used (or compatible)") # Python 3.6 is the lowest version tested so far

find_file(CONTRIB_PATH "contrib"
          PATHS "${APBS_ROOT}"
          DOC "The path to contributed modules for apbs")
find_file(EXTERNALS_PATH "externals"
          PATHS "${APBS_ROOT}"
          DOC "The path to the external git submodules")

set(SYS_LIBPATHS /usr/lib64)
#list(APPEND SYS_LIBPATHS /usr/lib64)

# If this option is true: static libraries will be built
#                         static dependencies will be preferred
#                         executables will be statically linked
# If this option is false: dynamic libraries will be built
#                          dynamic libraries of dependencies will be preferred
#                          executables will be dynamically linked
option(APBS_STATIC_BUILD "Flag to indicate whether a static build should be used (if false, will be dynamic)" ON)

if(APBS_STATIC_BUILD)
    set(FETK_STATIC_BUILD ON)
    set(BLA_STATIC ON)
    set(BUILD_SHARED_LIBS OFF)
    set(CMAKE_SKIP_RPATH ON)
    set(CMAKE_MACOSX_RPATH OFF)
    #set(CMAKE_LINK_SEARCH_START_STATIC ON)
    #set(CMAKE_LINK_SEARCH_END_STATIC ON)
    if(WIN32)
        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
        list(PREPEND CMAKE_FIND_LIBRARY_SUFFIXES .lib .a)
    else()
        list(PREPEND CMAKE_FIND_LIBRARY_SUFFIXES .a)
    endif()
    set(Python3_USE_STATIC_LIBS TRUE)
else()
    set(FETK_STATIC_BUILD OFF)
    set(BLA_STATIC OFF)
    set(BUILD_SHARED_LIBS ON)
    set(CMAKE_SKIP_RPATH OFF)
    set(CMAKE_MACOSX_RPATH ON)
    #set(CMAKE_LINK_SEARCH_START_STATIC OFF)
    #set(CMAKE_LINK_SEARCH_END_STATIC OFF)
    if(WIN32)
        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL$<$<CONFIG:Debug>:Debug>")
        list(PREPEND CMAKE_FIND_LIBRARY_SUFFIXES .dll)
    elseif(APPLE)
        list(PREPEND CMAKE_FIND_LIBRARY_SUFFIXES .dylib .so)
    else()
        list(PREPEND CMAKE_FIND_LIBRARY_SUFFIXES .so)
    endif()
    set(Python3_USE_STATIC_LIBS FALSE)
endif()

message(STATUS "")
message(STATUS "APBS Static build: ${APBS_STATIC_BUILD}")
message(STATUS "Building shared libs: ${BUILD_SHARED_LIBS}")
message(STATUS "Find-library suffixes: ${CMAKE_FIND_LIBRARY_SUFFIXES}")
message(STATUS "")

################################################################################
# Handle the Finite Element Toolkit
#
# To use a released version of FETK:
#   - Set FETK_VERSION to the version number (e.g. 1.8.0)
# In this case, the binary archive will be downloaded and used.
#
# To use a non-released version of FETK:
#   - Set FETK_VERSION to the git branch or commit hash you want to use (e.g. main)
################################################################################

# FETK is currently required, and therefore this option is disabled
#option(ENABLE_FETK "Enable the finite element solver" ON)

set(FETK_VERSION "57195e55351e04ce6ee0ef56a143c996a9aee7e2" CACHE STRING "Version of FETK to use")
include(ImportFETK)
import_fetk(${FETK_VERSION})


###############################################################################
##  NOTE: For Debugging and generally nice information to have
###############################################################################
string(TIMESTAMP COMPILE_TIME)
string(TIMESTAMP COMPILE_YEAR "%Y")

message(STATUS "#############################################################")
message(STATUS "** PROJECT NAME:  ${CMAKE_PROJECT_NAME}")
message(STATUS "** PROJECT DESC:  ${CMAKE_PROJECT_DESCRIPTION}")
message(STATUS "** PROJECT URL:   ${CMAKE_PROJECT_HOMEPAGE_URL}")
message(STATUS "** VERSION_DATA:  ${CMAKE_PROJECT_VERSION}")
message(STATUS "** CURRENT_TIME:  ${COMPILE_TIME}")
message(STATUS "** CURRENT_YEAR:  ${COMPILE_YEAR}")


################################################################################
# Set project paths                                                            #
################################################################################
message(STATUS "Setting project paths")

set(CMAKE_CXX_STANDARD 17)
if(WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -W4")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /LARGEADDRESSAWARE /STACK:100000000")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /LARGEADDRESSAWARE")
else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wpedantic -fpermissive -fPIC")
endif()
if(APPLE AND BUILD_SHARED_LIBS AND (${CMAKE_CXX_COMPILER_ID} MATCHES "GNU"))
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -undefined dynamic_lookup")
endif()


###############################################################################
#####  Boilerplate Setup
###############################################################################
# include(GNUInstallDirs)
# set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
# set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
# set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
# message(STATUS "** Project will be installed to ${CMAKE_INSTALL_PREFIX}")


###############################################################################
#####  Offer the builder the choice of overriding the installation directories
###############################################################################
# set(INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR} CACHE PATH "Installation directory for libraries")
# set(INSTALL_BINDIR ${CMAKE_INSTALL_BINDIR} CACHE PATH "Installation directory for executables")
# set(INSTALL_INCLUDEDIR ${CMAKE_INSTALL_INCLUDEDIR} CACHE PATH "Installation directory for header files")
# set(INSTALL_CMAKEDIR ${DEF_INSTALL_CMAKEDIR} CACHE PATH "Installation directory for CMake files")


###############################################################################
##### Report to builder
###############################################################################
# foreach(p LIB BIN INCLUDE CMAKE)
#   file(TO_NATIVE_PATH ${CMAKE_INSTALL_PREFIX}/${INSTALL_${p}DIR} _path )
#   message(STATUS "** Installing ${p} components to ${_path}")
#   unset(_path)
# endforeach()


################################################################################
# Debian/Ubuntu hack                                                           #
################################################################################
if(EXISTS "/etc/os-release" AND
  "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-as-needed")
endif()


################################################################################
# Set up temporary files and directories                                       #
################################################################################
set(TEMP_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/temp)
file(MAKE_DIRECTORY ${TEMP_OUTPUT_DIR})


################################################################################
# Set the lookup paths for external library dependencies                       #
################################################################################
message(STATUS "Setting lookup paths for headers and libraries")

set(CMAKE_INCLUDE_PATH "${CMAKE_INCLUDE_PATH}")
list(APPEND CMAKE_INCLUDE_PATH /usr/include)
list(APPEND CMAKE_INCLUDE_PATH /usr/local/include)


################################################################################
# Enable ansi pedantic compiling                                               #

=== requirements.txt ===
click
mmcif-pdbx
numpy
pybind11
pyparsing
python-dev-tools

=== docs/CMakeLists.txt ===
################################################################################
# TODO:  Generate license.html
################################################################################

################################################################################
# NOTE: Don't do this unless you have LaTex and way too much time to kill
################################################################################
option(BUILD_DOXYGEN "Build/Rebuild documentation using doxygen" OFF)

if(BUILD_DOXYGEN)

	find_package(Doxygen)

	if(Doxygen_FOUND)
		configure_file(
	    	${CMAKE_CURRENT_SOURCE_DIR}/programmer/.config/Doxyfile.in
	    	${CMAKE_CURRENT_BINARY_DIR}/programmer/Doxyfile
	    	ESCAPE_QUOTES
	    	)
	
		configure_file(
	    	${CMAKE_CURRENT_SOURCE_DIR}/programmer/.config/programmer.html.in
	    	${CMAKE_CURRENT_BINARY_DIR}/programmer/programmer.html
	    	)
	
		configure_file(
	    	${CMAKE_CURRENT_SOURCE_DIR}/programmer/.config/mainpage.h.in
	    	${CMAKE_CURRENT_BINARY_DIR}/programmer/mainpage.h
	    	)
	
		add_custom_target(
	    	doc
	    	ALL
	    	#COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/programmer/Doxyfile
	    	COMMAND doxygen ${CMAKE_CURRENT_BINARY_DIR}/programmer/Doxyfile
	    	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/programmer
	    	COMMENT "Generating documentation with Doxygen" VERBATIM
	  	)

		#file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/programmer/latex)
	
		add_custom_target(
	    	doc-pdf
	    	ALL
	    	COMMAND make
	    	COMMAND cp refman.pdf ../programmer.pdf
	    	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/programmer/latex
	    	DEPENDS doc
	    	COMMENT "Generating pdf documentation" VERBATIM
		)

    	install(DIRECTORY ${APBS_BUILD}/docs/programmer
            DESTINATION ${CMAKE_INSTALL_DATADIR}/docs
            PATTERN "Doxyfile" EXCLUDE
            PATTERN "latex" EXCLUDE
			PATTERN "mainpage.h" EXCLUDE
            COMPONENT docs
		)

	endif(Doxygen_FOUND)

endif()

################################################################################
# TODO:  Generate RTD for the APBS src
################################################################################
option(BUILD_BREATHE "Build/Rebuild documentation using Sphinx/Breathe for APBS src" OFF)

# This is part of issue https://github.com/Electrostatics/apbs/issues/41
# Based on https://devblogs.microsoft.com/cppblog/clear-functional-c-documentation-with-sphinx-breathe-doxygen-cmake/

message(STATUS "================================================================")
if(BUILD_BREATHE)
  message(STATUS "BUILD RTD using Sphinx/Breathe")
  find_package(Doxygen REQUIRED)

  include(FindPackageHandleStandardArgs)
  find_program(Sphinx_EXECUTABLE NAMES sphinx-build)

  # Find all the public headers
  file(GLOB_RECURSE APBS_SRC_PUBLIC_HEADERS ${PROJECT_SOURCE_DIR}/*.h)

  set(DOXYGEN_INPUT_DIR ${PROJECT_SOURCE_DIR}/src)
  set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/build)
  set(DOXYGEN_INDEX_FILE ${DOXYGEN_OUTPUT_DIR}/xml/index.xml)
  set(DOXYFILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
  set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

  # Replace variables inside @@ with the current values
  #configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

  # Doxygen won't create this for us
  file(MAKE_DIRECTORY ${DOXYGEN_OUTPUT_DIR})

  # Only regenerate Doxygen when the Doxyfile or public headers change
  add_custom_command(OUTPUT ${DOXYGEN_INDEX_FILE}
                     DEPENDS ${APBS_SRC_PUBLIC_HEADERS}
                     COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
                     MAIN_DEPENDENCY ${DOXYFILE_OUT} ${DOXYFILE_IN}
                     COMMENT "Generating docs"
                     VERBATIM)

  # Nice named target so we can run the job easily
  add_custom_target(Doxygen ALL DEPENDS ${DOXYGEN_INDEX_FILE})

  set(SPHINX_SOURCE ${CMAKE_CURRENT_SOURCE_DIR})
  set(SPHINX_BUILD ${CMAKE_CURRENT_BINARY_DIR}/sphinx)
  set(SPHINX_INDEX_FILE ${SPHINX_BUILD}/index.html)

  # Only regenerate Sphinx when:
  # - Doxygen has rerun
  # - Our doc files have been updated
  # - The Sphinx config has been updated
  add_custom_command(OUTPUT ${SPHINX_INDEX_FILE}
                     COMMAND 
                       ${Sphinx_EXECUTABLE} -b html
                       # - Tell Breathe where to find the Doxygen output
                       -Dbreathe_projects.src=${DOXYGEN_OUTPUT_DIR}/xml
                       ${SPHINX_SOURCE} ${SPHINX_BUILD}
                     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                     DEPENDS
                     # Other docs files you want to track should go here (or in some variable)
                       ${CMAKE_CURRENT_SOURCE_DIR}/index.rst
                       ${DOXYGEN_INDEX_FILE}
                     MAIN_DEPENDENCY ${SPHINX_SOURCE}/conf.py
                     COMMENT "Generating documentation with Sphinx")

  # Nice named target so we can run the job easily
  add_custom_target(Sphinx ALL DEPENDS ${SPHINX_INDEX_FILE})

  # Add an install target to install the docs
  include(GNUInstallDirs)
  install(DIRECTORY ${SPHINX_BUILD} DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT docs)

endif()
message(STATUS "================================================================")

=== docs/requirements.txt ===
sphinx
sphinx_rtd_theme
sphinx_sitemap

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)

macro(add_items TYPE)

    # Make sure the TYPE argument is valid
    set(ALLOWABLE_TYPES SOURCES EXTERNAL_HEADERS INTERNAL_HEADERS)
    list(FIND ALLOWABLE_TYPES ${TYPE} VALID_TYPE)
    if(VALID_TYPE EQUAL -1)
        message(
            FATAL_ERROR
            "Passed an invalid type to add_items macro.  "
            "Must be one of SOURCES, EXTERNAL_HEADERS, or INTERNAL_HEADERS.  "
            "Was ${TYPE}"
        )
    endif()

    # The items to add will be any additional parameters beyond TYPE
    set(ITEMS ${ARGN})

    # Add each item successively to the appropriately typed list
    foreach(ITEM ${ITEMS})
        list(APPEND ${TYPE} "${ITEM}")
    endforeach()

endmacro()

macro(add_sublibrary LIBRARY)
    set(LIBRARY_NAME "apbs_${LIBRARY}")
    set(LIBRARY_DEPENDENCIES ${APBS_LIBS} ${ARGN})
    message(STATUS "Adding ${LIBRARY_NAME}")
    message(STATUS "With source files ${SOURCES}")
    message(STATUS "With external header files ${EXTERNAL_HEADERS}")
    message(STATUS "With internal header files ${INTERNAL_HEADERS}")
    message(STATUS "With library dependencies ${LIBRARY_DEPENDENCIES}")
    add_library(${LIBRARY_NAME} ${SOURCES} ${EXTERNAL_HEADERS} ${INTERNAL_HEADERS})
    target_link_libraries(${LIBRARY_NAME} ${LIBRARY_DEPENDENCIES})
    #add_dependencies(${LIBRARY_NAME} ${LIBRARY_DEPENDENCIES})
    INSTALL(FILES ${EXTERNAL_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${LIBRARY} COMPONENT headers)
    INSTALL(TARGETS ${LIBRARY_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libraries)
    list(APPEND APBS_INTERNAL_LIBS ${LIBRARY_NAME})
    set(APBS_INTERNAL_LIBS ${APBS_INTERNAL_LIBS} PARENT_SCOPE)
    message(STATUS "Added ${LIBRARY_NAME}")
    set(SOURCES) # clear the SOURCES variable
endmacro()

add_subdirectory(generic)
add_subdirectory(pmgc)
add_subdirectory(mg)

add_subdirectory(fem)

if(ENABLE_GEOFLOW)
#    add_items(SOURCES geoflow_wrap_apbs.c)
     add_subdirectory(geoflow)
endif(ENABLE_GEOFLOW)

add_items(SOURCES routines.c)
add_sublibrary(routines ${APBS_LIBS} ${APBS_INTERNAL_LIBS})

message(STATUS "External Headers: ${EXTERNAL_HEADERS}")

#add_executable(apbs main.c routines.c)
add_executable(apbs main.c)
message(STATUS " ")
message(STATUS "APBS Libraries: ${APBS_LIBS}")
message(STATUS "Internal Libraries: ${APBS_INTERNAL_LIBS}")
message(STATUS " ")

# Use position-independent code for apbs
set_property(TARGET apbs PROPERTY POSITION_INDEPENDENT_CODE TRUE)

#add_dependencies(apbs ${BEM_LIB})
#target_include_directories(apbs PRIVATE apbs.h routines.h)
target_link_libraries(apbs ${APBS_LIBS} ${APBS_INTERNAL_LIBS})
if(APPLE)
    target_link_libraries(apbs "-framework CoreFoundation")
endif()
#add_dependencies(apbs ${APBS_LIBS} ${APBS_INTERNAL_LIBS} ${APBS_LIBS})


################################################################################
#  We have to fix the dynamically linked libraries 
################################################################################
#if(APPLE)
#  set(HARDPATH "${PROJECT_BINARY_DIR}/fetk/lib")
#  foreach (hardlib ${APBS_LIBS})
#    set(HARDNAME "lib${hardlib}.1.dylib")
#    message(STATUS "#############################################################")
#    message(STATUS "#############################################################")
#    message(STATUS "#############################################################")
#    message(STATUS "#############################################################")
#    message(STATUS "** Change path for hardlib - ${hardlib}")
#    message(STATUS "COMMAND install_name_tool -change ${HARDPATH}/${HARDNAME} @executable_path/../lib/${HARDNAME} ${PROJECT_BINARY_DIR}/bin/apbs")
#    message(STATUS "#############################################################")
#    add_custom_command(TARGET apbs POST_BUILD
#                       COMMAND install_name_tool -change ${HARDPATH}/${HARDNAME} @executable_path/../lib/${HARDNAME} ${PROJECT_BINARY_DIR}/bin/apbs
#    )
#  endforeach()
#endif()

INSTALL(FILES apbs.h routines.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT headers)
INSTALL(TARGETS apbs DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT executables)

message(STATUS ${CMAKE_C_FLAGS})

=== tests/CMakeLists.txt ===
include (CTest)
enable_testing()

message(STATUS "******* TESTING ADDED *****************")
#set (Python3_FIND_ABI "OFF" "ANY" "ANY")
find_package(Python3 ${PYTHON_VERSION} EXACT REQUIRED COMPONENTS Interpreter)

set(APBS_BINARY "apbs")
if(CMAKE_HOST_WIN32)
  set(APBS_BINARY "apbs.exe")
endif()

set(TESTS_CFG_FILE ${CMAKE_SOURCE_DIR}/tests/test_cases.cfg)

if(EXISTS ${TESTS_CFG_FILE})
    file(READ ${TESTS_CFG_FILE} TEST_CASES_FILE)
    string(REPLACE "\n" ";" TEST_CASES_LINES ${TEST_CASES_FILE}) 
    foreach(_line ${TEST_CASES_LINES})
        if(${_line} MATCHES "^\\[")
            string(REPLACE "[" "" _line ${_line})
            string(REPLACE "]" "" _line ${_line})
            string(REGEX REPLACE "[-].*$" "" _shortname ${_line})
            string(TOUPPER "ENABLE_${_shortname}" OPTION_NAME)
            message(STATUS "******* FOUND TEST CASE ${_shortname}, ${_line}")
            if (DEFINED "${OPTION_NAME}" AND NOT ${OPTION_NAME})
                message(STATUS "******* SKIPPING TEST CASE ${_shortname}, ${_line}")
            else()
                message(STATUS "TEST  ${_line}_test  WORKING_DIRECTORY  ${CMAKE_SOURCE_DIR}/tests  COMMAND ${Python3_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tests/apbs_tester.py -e ${APBS_BINARY} -t ${_line}")
                add_test(NAME        "${_line}_test" WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/tests" COMMAND ${Python3_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tests/apbs_tester.py -e ${APBS_BINARY} -t ${_line})
            endif()
        endif()
    endforeach()
else()
    message(FATAL  "******* MISSING Test Config (${TESTS_CFG_FILE})")
endif()

=== tools/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${TOOLS_PATH}/bin)

add_subdirectory(mesh)
add_subdirectory(manip)

if(ENABLE_PYTHON)
    add_subdirectory(python)
    add_subdirectory(python-pybind)
endif(ENABLE_PYTHON)

unset(EXECUTABLE_OUTPUT_PATH)

=== contrib/iapbs/CMakeLists.txt ===
################################################################################
# Set up basic project stuff                                                   #
################################################################################
cmake_minimum_required(VERSION 3.6)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckTypeSize)
include(ExternalProject)

set(iAPBS_VERSION "3.2.0")

PROJECT(iAPBS)
################################################################################
# Set project paths                                                            #
################################################################################

message(STATUS "Setting iAPBS project paths")
set(iAPBS_ROOT ${PROJECT_SOURCE_DIR})


################################################################################
# add src
################################################################################


add_subdirectory(src)

#get_cmake_property(_variableNames VARIABLES)
#foreach (_variableName ${_variableNames})
#    message(STATUS "${_variableName}=${${_variableName}}")
#endforeach()

=== src/fem/CMakeLists.txt ===
add_items(
    SOURCES
    vcsm.c
    vfetk.c
    vpee.c
)

add_items(
    EXTERNAL_HEADERS
    vcsm.h
    vfetk.h
    vpee.h
)

add_sublibrary(fem apbs_generic)

=== src/generic/CMakeLists.txt ===
add_items(
    SOURCES
    nosh.c
    mgparm.c
    femparm.c
    pbamparm.c
    pbsamparm.c
    pbeparm.c
    bemparm.c
    geoflowparm.c
    apolparm.c
    vacc.c
    valist.c
    vatom.c
    vpbe.c
    vcap.c
    vclist.c
    vstring.c
    vparam.c
    vgreen.c
)

add_items(
    EXTERNAL_HEADERS
    nosh.h
    mgparm.h
    femparm.h
    pbamparm.h
    pbsamparm.h
    pbeparm.h
    bemparm.h
    geoflowparm.h
    apolparm.h
    vacc.h
    valist.h
    vatom.h
    vpbe.h
    vcap.h
    vclist.h
    vstring.h
    vparam.h
    vgreen.h
    vmatrix.h
    vhal.h
    vunit.h
)

add_sublibrary(generic)

=== src/geoflow/CMakeLists.txt ===
add_items(
    SOURCES
    geoflow_wrap_apbs.cpp
)

add_items(
    EXTERNAL_HEADERS
    geoflow_wrap_apbs.h
)

add_sublibrary(geoflow_apbs)

=== src/mg/CMakeLists.txt ===
add_items(
    SOURCES
    vgrid.c
    vmgrid.c
    vopot.c
    vpmg.c
    vpmgp.c
)

add_items(
    EXTERNAL_HEADERS
    vgrid.h
    vmgrid.h
    vopot.h
    vpmg.h
    vpmgp.h
)

add_sublibrary(mg apbs_generic apbs_pmgc)

=== debian/changelog ===
apbs (3.4.1-7) unstable; urgency=medium

  * Team upload.
  [ Adrian Bunk ]
  * Build with -std=gnu17 to workaround FTBFS with GCC 15.
    Closes: #1096316.

 -- Santiago Vila <sanvila@debian.org>  Sun, 21 Sep 2025 17:25:00 +0200

apbs (3.4.1-6) unstable; urgency=medium

  * Team upload.

  [ Drew Parsons ]
  * fix build with gcc-14. Closes: #1077646.
    - patch vf2c in debian/external_deps/fetk
    - debian patch gcc14.patch reverts an upstream hack in vfetk
      function definitions that prevent building with gcc-14.
  * add hashbang to debian/tests/test-apbs. Thanks Simon Chopin.
    Closes: #1033528.
  * Build-Depends: pkgconf not pkg-config
  * mark apbs-doc Multi-Arch: foreign
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Thu, 31 Oct 2024 14:24:17 +0100

apbs (3.4.1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061891

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 01:04:53 +0000

apbs (3.4.1-5) unstable; urgency=medium

  * Team upload.
  * Add patch to drop obsolete "U" mode passed to open(), which causes runtime
    errors with python 3.11, by Steve Langasek. Closes: #1028354.

 -- Michael Banck <mbanck@debian.org>  Tue, 10 Jan 2023 21:56:38 +0100

apbs (3.4.1-4) unstable; urgency=medium

  * Team upload.
  * update patch on FETK punc component vf2c/uninit.c to test for
    availability of _FPU_MASK_IM rather than __mips to allow riscv64
    to build.
  * patch FETK punc component vf2c/uninit.c to define Masks for
    riscv64 interrupts. Thanks Bo YU. Closes: #1012302.
  * Standards-Version: 4.6.1

 -- Drew Parsons <dparsons@debian.org>  Sat, 04 Jun 2022 09:58:09 +0200

apbs (3.4.1-3) unstable; urgency=medium

  * Team upload.
  * patch FETK punc component vf2c/uninit.c to use specific MIPS fpu
    masks with _FPU_SETCW. Closes: #1012177.

 -- Drew Parsons <dparsons@debian.org>  Wed, 01 Jun 2022 13:43:34 +0200

apbs (3.4.1-2) unstable; urgency=medium

  * Team upload.
  * Build-Depends-Indep: python3-yaml (to build docs)
  * add specific copyright entries for FETK components
    punc/src/pmg (GPL) and punc/src/vf2c (AT&T)
  * patch FETK punc component vf2c/uninit.c to not run __mips block on
    linux
  * don't double-up bin dir in path for apbs tools. Closes: #979339.
  * debian/rules: run build-time tests after dh_auto_install
  * FETK is now provided (built against system SuperLU), and debci
    tests pass. Closes: #1006382, #1008726.

 -- Drew Parsons <dparsons@debian.org>  Tue, 31 May 2022 02:52:47 +0200

apbs (3.4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - requires FETK
    - Build-Depends: pybuild-plugin-pyproject, python3-pybind11
    - drop deprecated debian patches debian_make.patch and
      link_libapbs_routines.patch
  * provide FETK external source as a git subtree in
    debian/external_deps/fetk. Source is pulled from
    https://github.com/Electrostatics/FETK, the required
    version is specified in the toplevel apbs CMakeLists.txt
    - pull FETK 1.9.3 (commit 57195e5) to use system SuperLU
    - patch to use system maloc (don't build local maloc)
    - patch mc and punc with BLA_STATIC OFF to used BLAS shared
      libraries, and don't specify BLA_VENDOR OpenBLAS (use generic
      blas to allow for alternative optimised BLASes)
    - build FETK libraries (libmc.so, libgamer.so, libpunc.so,
      also punc components libcgcode.so, libvf2c.so)
      with soname set by FETK project minor version (currently 1.9)
    - provide FETK libraries in libfetk-dev and libfetk1.9 packages.
    - FETK copyright licence is LGPL-2.1+
    - Build-Depends: libsuitesparse-dev (for libumfpack),
      libarpack2-dev
  * python3-apbslib provides both apbs and apbslib python modules
  * update debian/rules
    - specify cmake build with source at top level
    - specify APBS_STATIC_BUILD=Off
  * update debian patch python3.patch to fix check of PYTHON_MAX_VERSION
    and only copy python library files to a pdb2pka dir it exists
  * add debian patch cmake.patch
    - adjusts upstream cmake files to install headers in
      /usr/include/apbs, and don't install (unformed) docs
    - add RPC_CFLAGS (/usr/include/tirpc) to CFLAGS in
      ImportFETK.cmake to include FETK RPC support.
      Build-Depends: libtirpc-dev (using pkg-config)
    - treat PYTHON_VERSION (3.6) as minimum not exact version
    - skip RPATH in shared library build (CMAKE_SKIP_RPATH=ON)
  * provide apbs-doc package
    - build user docs with sphinxdoc, libjs-mathjax
    - Build-Depends-Indep: python3-sphinx-rtd-theme
  * fix ©,Å symbols with UTF-8 via debian patch
    fix_spelling_errors.patch and direct in FETK
  * add apbs_check_intermediate_energies.py to
    debian patch wrong-path-for-interpreter.patch and replace with
    "env python3" as needed (following upstream more closely)
  * update upstream source to https://github.com/Electrostatics/apbs
  * upstream source no longer includes pdb2pqr, don't need to
    exclude it and repackage the source (drop +dfsg1)
  * Standards-Version: 4.6.0
  * lintian updates

 -- Drew Parsons <dparsons@debian.org>  Sun, 29 May 2022 10:42:09 +0200

=== debian/control ===
Source: apbs
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
 debhelper-compat (= 13),
 dh-python,
 pybuild-plugin-pyproject,
 pkgconf,
 libarpack2-dev,
 libmaloc-dev,
 libsuitesparse-dev,
 libsuperlu-dev,
 libtirpc-dev,
 mpi-default-dev,
 python3,
 python3-dev,
 python3-pybind11,
 python3-setuptools,
 python3-sphinx | sphinx,
 swig,
 zlib1g-dev
Build-Depends-Indep: libjs-mathjax,
 python3-sphinx-rtd-theme,
 python3-yaml
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debichem-team/apbs
Vcs-Git: https://salsa.debian.org/debichem-team/apbs.git
Homepage: http://www.poissonboltzmann.org/

Package: apbs
Architecture: any
Depends: apbs-data (= ${source:Version}),
 libapbs3t64 (= ${binary:Version}),
 libjs-mathjax,
 ${misc:Depends},
 ${shlibs:Depends},
 ${sphinxdoc:Depends}
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.  Continuum electrostatics plays an
 important role in several areas of biomolecular simulation, including:
 .
   * simulation of diffusional processes to determine ligand-protein and
     protein-protein binding kinetics,
   * implicit solvent molecular dynamics of biomolecules ,
   * solvation and binding energy calculations to determine
     ligand-protein and protein-protein equilibrium binding constants
     and aid in rational drug design,
   * and biomolecular titration studies.
 .
 APBS was designed to efficiently evaluate electrostatic properties for
 such simulations for a wide range of length scales to enable the
 investigation of molecules with tens to millions of atoms.
 .
 This package contains the apbs program and utilities.

Package: python3-apbslib
Section: python
Architecture: any
Depends: libapbs3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.
 .
 This package provides both the apbs and apbslib modules for Python3
 enabling Python applications to access apbs.

Package: libapbs-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libapbs3t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.
 .
 This package contains the development headers to build against
 libapbs_* shared libraries.

Package: libapbs3t64
Provides: ${t64:Provides}
Replaces: libapbs3
Breaks: libapbs3 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.
 .
 This package contains the libapbs_* shared libraries.

Package: apbs-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: apbs (<= 1.4-2)
Description: data files for APBS (Adaptive Poisson Boltzmann Solver)
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.
 .
 This package contains all data files for apbs package to reduce the 
 redundancy between architectures in Debian.

Package: apbs-doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-mathjax,
 ${misc:Depends},
 ${sphinxdoc:Depends}
Recommends: apbs
Suggests: python3-apbslib
Description: Adaptive Poisson Boltzmann Solver
 APBS is a software package for the numerical solution of the
 Poisson-Boltzmann equation (PBE), one of the most popular continuum
 models for describing electrostatic interactions between molecular
 solutes in salty, aqueous media.  Continuum electrostatics plays an
 important role in several areas of biomolecular simulation, including:
 .
   * simulation of diffusional processes to determine ligand-protein and
     protein-protein binding kinetics,
   * implicit solvent molecular dynamics of biomolecules ,
   * solvation and binding energy calculations to determine
     ligand-protein and protein-protein equilibrium binding constants
     and aid in rational drug design,
   * and biomolecular titration studies.
 .
 APBS was designed to efficiently evaluate electrostatic properties for
 such simulations for a wide range of length scales to enable the
 investigation of molecules with tens to millions of atoms.
 .
 This package contains the apbs documentation.

Package: libfetk-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfetk1.9t64 (= ${binary:Version}),
 libmaloc-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: FETK libraries for APBS (development headers)
 The Finite Element ToolKit (FETK) is a collection of adaptive finite
 element method (AFEM) software libraries and tools for solving
 coupled systems of nonlinear geometric partial differential equations
 (PDE). The FETK libraries and tools are written in an object-oriented
 form of ANSI-C and in C++, and include a collection of standard
 numerical libraries (PUNC), a stand-alone high-quality surface and
 volume simplex mesh generator (GAMer), a stand-alone networked
 polygon display tool (SG), a general nonlinear finite element
 modeling kernel (MC)
 .
 This package provides a fork of FETK intended for use by APBS
 (Adaptive Poisson Boltzmann Solver).
 .
 The FETK component MALOC (Minimal Abstraction Layer for
 Object-oriented C/C++ programs) is provided separately by
 libmaloc-dev.
 .
 This package contains the development headers to build against
 libapbs_* shared libraries.

Package: libfetk1.9t64
Provides: ${t64:Provides}
Replaces: libfetk1.9
Breaks: libfetk1.9 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: FETK libraries for APBS (shared libraries)
 The Finite Element ToolKit (FETK) is a collection of adaptive finite
 element method (AFEM) software libraries and tools for solving
 coupled systems of nonlinear geometric partial differential equations
 (PDE). The FETK libraries and tools are written in an object-oriented
 form of ANSI-C and in C++, and include a collection of standard
 numerical libraries (PUNC), a stand-alone high-quality surface and
 volume simplex mesh generator (GAMer), a stand-alone networked
 polygon display tool (SG), a general nonlinear finite element
 modeling kernel (MC)
 .
 This package provides a fork of FETK intended for use by APBS
 (Adaptive Poisson Boltzmann Solver).
 .
 The FETK component MALOC (Minimal Abstraction Layer for
 Object-oriented C/C++ programs) is provided separately via
 libmaloc-dev.
 .
 This package contains the libgamer, libmc, libpunc (and libcgcode,
 libvf2c) shared libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk
include /usr/share/mpi-default-dev/debian_defaults

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# FETK needs SuperLU, make sure the system library is used
SUPERLU_INCLUDES = $(shell pkg-config --cflags-only-I superlu | sed "s/^-I//" )
SUPERLU_LIBRARIES = $(shell pkg-config --libs superlu | sed "s/^-l//" )

BUILDDIR := $(CURDIR)/obj-$(DEB_HOST_MULTIARCH)

export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) -fcommon -std=gnu17
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

%:
	dh $@ --with python3,sphinxdoc --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=None \
		-DAPBS_STATIC_BUILD=Off \
		-DBUILD_DOC=Off -DBUILD_TOOLS=On \
		-DENABLE_OPENMP=On -DENABLE_MPI=On \
		-DENABLE_PYTHON=On -DBUILD_SHARED_LIBS=On \
		-DENABLE_READLINE=Off -DENABLE_ZLIB=On \
		-DFETCHCONTENT_SOURCE_DIR_FETK=$(CURDIR)/debian/external_deps/fetk \
		-DRPC_CFLAGS=$(shell pkg-config --cflags libtirpc) \
		-DBUILD_MALOC=Off

execute_after_dh_auto_build-indep: export http_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
execute_after_dh_auto_build-indep:
	PYTHONPATH=$(BUILDDIR)/tools/python sphinx-build -b html docs $(BUILDDIR)/docs/_build/html # HTML generator

override_dh_auto_test:
# run tests after installation

execute_after_dh_auto_install:
	-(cd tests; PATH=$(CURDIR)/debian/tmp/usr/bin:$${PATH} LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$${LD_LIBRARY_PATH} PYTHONPATH=$${PYTHONPATH}:$(CURDIR)/tools/manip python3 apbs_tester.py -c test_cases.cfg; rm -rf __pycache__)

override_dh_fixperms-indep:
	dh_fixperms
	for example in FKBP/1d7h-dmso/UHBD/pqr2qcd \
			ion-pmf/runme.sh \
			point-pmf/runme.sh \
			protein-rna/postprocess.sh \
			protein-rna/test.sh \
			helix/Run_membrane-helix.sh \
			protein-rna/run_apdx_files.sh; \
	do \
	  chmod +x debian/apbs-data/usr/share/apbs/examples/$${example}; \
	done
	for script in amber2charmm.sh \
			param/pdb2pqr/amber2uhbd.sh \
			qcd2pqr.awk; \
	do \
	  chmod a+x debian/apbs-data/usr/share/apbs/tools/conversion/$${script}; \
	done
	for example in bem-pKa/test_proteins \
			pbsam-barn_bars; \
	do \
	  chmod a-x debian/apbs-data/usr/share/apbs/examples/$${example}/*.pqr; \
	done

=== debian/tests/control ===
Tests: test-apbs
Depends: @, python3
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/Electrostatics/apbs/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
